## Name

gfhost — Gfarm filesystem node management command

## Synopsis

`gfhost` [ -H | -l | -M ] [-iLprUv] [-P `path`] [-a `architecture`] [-D `domain-name`] [-j `concurrency`] [`hostname`...]

`gfhost` -c [-P `path`] -a `architecture` -p `port-number` [-n `number-of-CPUs`] [-f `flags`] `hostname`

`gfhost` -m [-P `path`] [-a `architecture`] [-p `port-number`] [-n `number-of-CPUs`] [-f `flags`] `hostname`

`gfhost` -d [-P `path`] `hostname`...

`gfhost` -R [-P `path`]

## DESCRIPTION

gfhost displays the information of filesystem nodes. It also registers a new filesystem node, and modifies and deletes the registered information.

The function of gfhost is determined by the option, -c, -m, -d, -H, -l, -M, and -R. These functions are mutually exclusive, and only one option among them can be specified. If none of them is specified, filesystem nodes will be listed, which is the default function of gfhost.

## FUNCTIONS

The Gfarm filesystem manages filesystem nodes at the gfmd metadata server. The -c option registers a new filesystem node. The -m option modifies the registered information. The -d option removes an entry of the filesystem node and related file metadata. The -R option restores the dumped information of filesystem nodes, which is obtained by the -M option. These operations require gfarmadm privilege.

The -H, -l, -M, or no functional option is specified, gfhost displays filesystem node information. The -M lists the registered information of filesystem nodes at the gfmd metadata server. Other options access gfsd filesystem daemon to obtain more information and also to check the accessibility to a filesystem node. The -i, -j, -U and -v options are available.

When hostnames of filesystem nodes are not specified, all registered hosts will be displayed, but you can limit the type of hosts displayed by the -a and/or -D option. By default, hosts are displayed in alphabetical order, but you can change this by the -L, -p, or -r option, although the -L option is effective with -H or -l option.

The following is a list of the functions of the gfhost command. You shouldn't specify more than one function at a time.

<none>

  When no function is specified, gfhost accesses to gfsd, and displays the host names which are currently available. They are displayed in alphabetical order, by default.

`-c`

  Creates a host entry of a filesystem node that is specified by the argument. The -a option is mandatory, which specifies the architecture of the filesystem node. The -p option is mandatory, which specifies the port number of gfsd on the filesystem node. The -n option is optional, which specifies the number of CPUs of the filesystem node. When it is omitted, 1 CPU is assumed. The -f option is optional, which specifies the flag of the file system node. When it is omitted, 0 is assumed.

`-d`

  Deletes a host entry. All file metadata is also asynchronously updated to delete invalid replica entries for the removed filesystem node, and to create file replicas if required, automatically.

`-l`

  Displays in a long format, which consists of the CPU load average, authentication method, architecture, the number of CPUs, hostname, port number, flags, and the IP address.

  If the host cannot be accessed due to a machine down or a network problem, etc., x.xx/x.xx/x.xx will be displayed in the CPU load average field. If the host is up, but gfsd on the host cannot be accessed, -.--/-.--/-.-- will be displayed.

  In the field of the authentication method, `G' means the GSI authentication and the encryption, `g' means only authentication is performed by GSI and actual communication is unprotected plain data (gsi_auth), `s' means the gfarm sharedsecret authentication, `x' means that the authentication fails, and `-' means that the authentication wasn't actually tried. With the -U option, there is no authentication method field.

  In the field of the flags, refer to the -f option.

  Hostnames are displayed in alphabetical order, by default.

`-H`

  Displays filesystem nodes with the CPU load average and the authentication method. This function also displays the IP address used to access to gfsd in parentheses just after the hostname.

  For the field of the CPU load average and the authentication method, refer to the -l option.

  Hostnames are displayed in alphabetical order, by default.

`-M`

  Dumps the metadata information of the registered filesystem nodes. Hostnames are displayed in alphabetical order, by default.

`-m`

  Modifies the registered metadata information of the filesystem node. The -a, -p, -n, and/or -f option modify the current value of each option.

`-R`

  Restores the metadata information read from standard input. The format of the metadata is same as the format that the -M function displays.

`-?`

  Prints usage.

## OPTIONS

`-a` `architecture`

  This option specifies the CPU architecture using a format like sparc-sun-solaris8 or i386-redhat8.0-linux, etc. If this option is used with the -c or -m function, this means the architecture used to add/modify the metadata information. If this option is used with -H, -l, -M function or default function, this limits hosts to the specified architecture.

`-D` `domain-name`

  This option is used with the -H, -l, -M function or the default function to limit hosts to the specified domain.

`-i`

  There is an "address_use" directive in %%SYSCONFDIR%%/gfarm2.conf and $HOME/.gfarm2rc to give priorities of network addresses for gfarm access. This directive works with the gfhost command, but will be ignored, if you specified the -i option with gfhost.

`-j` `concurrency`

  This option specifies the concurrency used for access to gfsd. The default value is 10.

`-L`

  Sorts by load average order. This option is effective only with the -H and -l functions.

`-n` `number-of-CPUs`

  This option is used with the -c or -m function, and specifies the number of CPUs of the host.

`-p` `port-number`

  This option is used with -c or -m function, and specifies the port number of gfsd on the host.

`-f` `flags`

  This option is used with -c or -m function, and specifies the flags of gfsd on the host. Values of flags are constructed by a bitwise-or of the following list.

  `1`

    readonly

`-P` `path`

  This option specifies a pathname or a Gfarm URL to identify a metadata server which will be accessed by this command. If not specified, "/" is used as the default value.

`-r`

  Reverses the order of sort.

`-u`

  Plain order. This option stops sorting on the -H, -l, -M function or the default function. With the -M function, command argument order (if any), or the order that the metadata server answers is used for display. With the -H, -l function or the default function, the result is displayed in the order that each gfsd answers.

`-U`

  Suppresses authentication attempts by TCP, and only queries load average by UDP. This option only makes sense if you specified the -H or -l function, or if you didn't specify any function. This option makes the gfhost command run faster. If the -H or -l function is specified, this option makes the authentication method field disappear.

`-v`

  The -H, -l function and the default function don't produce error reports on gfsd accesses; these error reports will be produced by this option.

## SEE ALSO

gfarm2.conf(5), gfsd(8)